﻿#include <iostream>
#include "../Include/FAS_EziMOTIONPlusE.h"

using namespace PE;

#define TCP 0
#define UDP 1

bool Connect(int nCommType, int nBdID);
bool SetParameter(int nBdID);

int main()
{
	int nBdID = 0;

	// Device Connect
	if (Connect(TCP, nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Load and Set Parameter
	if (SetParameter(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Connection Close
	FAS_Close(nBdID);

	getchar();
}

bool Connect(int nCommType, int nBdID)
{
	unsigned char byIP[4] = { 192, 168, 0, 2 }; // IP : 192.168.0.2
	bool bSuccess = true;

	// Connection
	switch (nCommType)
	{
	case TCP:
		// TCP Connection
		if (FAS_ConnectTCP(byIP[0], byIP[1], byIP[2], byIP[3], nBdID) == 0)
		{
			printf("TCP Connection Fail! \n");
			bSuccess = false;
		}
		break;

	case UDP:
		// UDP Connection
		if (FAS_Connect(byIP[0], byIP[1], byIP[2], byIP[3], nBdID) == 0)
		{
			printf("UDP Connection Fail! \n");
			bSuccess = false;
		}
		break;

	default:
		printf("Wrong communication type. \n");
		bSuccess = false;

		break;
	}

	if (bSuccess)
		printf("Connected successfully. \n");

	return bSuccess;
}

bool SetParameter(int nBdID)
{
	int nRtn;
	int nChangeValue = 100;
	int lParamVal = 0;

	printf("----------------------------------------------------------------------------- \n");
	// Check The Axis Start Speed Parameter Status
	nRtn = FAS_GetParameter(nBdID, SERVO2_AXISSTARTSPEED, &lParamVal);
	if (nRtn != FMM_OK)
	{
		printf("Function(FAS_GetParameter) was failed.\n");
		return false;
	}
	else
	{
		printf("Load Parameter[Before] : Start Speed = %d[pps] \n", lParamVal);
	}

	printf("----------------------------------------------------------------------------- \n");
	// Change the (Axis Start Speed Parameter) value to (nChangeValue) value.
	nRtn = FAS_SetParameter(nBdID, SERVO2_AXISSTARTSPEED, nChangeValue);
	if (nRtn != FMM_OK)
	{
		printf("Function(FAS_SetParameter) was failed.\n");
		return false;
	}
	else
	{
		printf("Set Parameter: Start Speed = %d[pps] \n", nChangeValue);
	}

	printf("----------------------------------------------------------------------------- \n");
	// Check the changed Axis Start Speed Parameter again.
	nRtn = FAS_GetParameter(nBdID, SERVO2_AXISSTARTSPEED, &lParamVal);
	if (nRtn != FMM_OK)
	{
		printf("Function(FAS_GetParameter) was failed.\n");
		return false;
	}
	else
	{
		printf("Load Parameter[After] : Start Speed = %d[pps]\n", lParamVal);
	}

	return true;
}
