GetInputExam 예제
=================

## 1. Input / Latch 상태 읽기
----------------------------

``` c++
unsigned int uInput = 0;
unsigned int uLatch = 0;
bool bON;

if (FAS_GetInput(nBdID, &uInput, &uLatch) != FMM_OK)
{
	printf("Function(FAS_GetInput) was failed.\n");
	return false;
}
```

FAS_GetInput() 함수를 사용하여 Input bit와 Latch에 대한 정보를 읽을 수 있습니다.

## 2. Input bit 출력
-------------------

``` c++
for (int i = 0; i < 16; i++)
{
	bON = ((uInput & (0x01 << i)) != 0);
	printf("Input bit %d is %s.\n", i, ((bON) ? "ON" : "OFF"));
}
```

uInput에 저장된 데이터를 통하여 0~15번의 Input bit를 출력합니다.

### 2.1 수신 데이터의 구조

uInput(32bit)의 LSB에 0번 Input bit부터 MSB에 31번 Input bit가 순차적으로 쓰여집니다.
uLatch(32bit)의 LSB에 0번 Latch부터 MSB에 31번 Latch가 순차적으로 쓰여집니다.

## 3. 예제 프로그램 시나리오 설명
--------------------------------

해당 예제프로그램의 시나리오는 아래와 같습니다.

1. 장치 연결.
2. Input / Latch 상태 읽기.
2. Input bit 출력.
3. 연결 해제.

## 4. 기타
---------

1. 장치 연결 및 해제에 대한 함수 설명은 [01.ConnectionExam] 프로젝트 문서를 참고하시기 바랍니다.
