MoveLinearAbsIncPosExam 예제
========================

## 1. 직선 보간 이송 (상대 좌표)
----------------------------

``` c++
// Move Linear IncPos
int lIncPos[2] = { 370000, 370000 };
int lVelocity = 0;
WORD wAccelTime = 100;

printf("---------------------------\n");
// Increase the motor by 370000 pulse (target position : Relative position)

lVelocity = 40000;

printf("[Linear Inc Mode] Move Motor! \n");

if (FAS_MoveLinearIncPos2(2, nBdID, lIncPos, lVelocity, wAccelTime) != FMM_OK)
{
	printf("Function(FAS_MoveLinearIncPos2) was failed.\n");
	return false;
}
```

FAS_MoveLinearIncPos2() 함수를 사용하여 상대 좌표 직선 보간 이송을 수행할 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'직선 보간할 드라이브의 수', '드라이브들의 ID배열', '좌표 배열', '속도', '가감속 시간'

### 1.1 드라이브 상태값

``` c++
EZISERVO2_AXISSTATUS AxisStatus;

// Check the Axis status until motor stops and the Inposition value is checked
for (INT nID = 0; nID < SLAVE_CNT; nID++)
{
	do
	{
		Sleep(1);

		if (FAS_GetAxisStatus(nBdID[nID], &(AxisStatus.dwValue)) != FMM_OK)
		{
			printf("[nBdID : %d ] Function(FAS_GetAxisStatus) was failed.\n", nBdID[nID]);
			return false;
		}
	} while (AxisStatus.FFLAG_MOTIONING || !(AxisStatus.FFLAG_INPOSITION));
}
```

EZISERVO2_AXISSTATUS 는 드라이브 상태값이 정리된 구조체이며 헤더파일 (MOTION_EziSERVO2_DEFINE.h)에서 확인하실 수 있습니다.
위 소스 코드는 0축~SLAVE_CNT에 해당하는 축이 Inposition에 위치할 때 까지 기다리는 기능입니다.

## 2. 직선 보간 이송 (절대 좌표)
----------------------------

``` c++
// Move Linear AbsPos 
int lAbsPos[2] = { 0, 0 };
int lVelocity = 0;
WORD wAccelTime = 100;

printf("---------------------------\n");

// Move the motor by 0 pulse (target position : Absolute position)
lVelocity = 40000;

printf("[Linear Abs Mode] Move Motor! \n");
if (FAS_MoveLinearAbsPos2(2, nBdID, lAbsPos, lVelocity, wAccelTime) != FMM_OK)
{
	printf("Function(FAS_MoveLinearAbsPos2) was failed.\n");
	return false;
}
```

FAS_MoveLinearIncPos2() 함수를 사용하여 절대 좌표 직선 보간 이송을 수행할 수 있습니다.
해당 함수의 각 파라미터는 '상대 좌표 직선 보간 이송'과 동일합니다.

## 3. 예제 프로그램 시나리오 설명
-----------------------------

해당 예제프로그램의 시나리오는 아래와 같습니다.

1. 장치 연결.
2. 드라이브 에러 체크.
3. 드라이브 Servo ON.
4. 직선 보간 이송 (상대 좌표).
5. 직선 보간 이송 (절대 좌표).
6. 연결 해제.

## 4. 기타
---------

1. 장치 연결 및 해제에 대한 함수 설명은 [01.ConnectionExam] 프로젝트 문서를 참고하시기 바랍니다.
2. 드라이버 에러 체크에 대한 함수 설명은 [05.JogMovementExam] 프로젝트 문서를 참고하시기 바랍니다.
