ConfigADExam 예제
=================

## 1. AD 파라미터 설정
--------------------

``` c++
BYTE byChannel = 0;			//Channel = 0
int lADRange = 0;			//AD Range = 0
int lFilterLen = 1000;		//Filter Length = 1000
int lFilterOffset = -1000;	//Filter Offset = -1000
int lRecv = 0;

printf("---------------------------------- \n");
// Set AD Range to 0 (-10 ~ 10[V])
if (FAS_SetADConfig(nBdID, byChannel, TYPE_AD_RANGE, lADRange, &lRecv) != FMM_OK)
{
	printf("Function(FAS_SetADConfig) was failed.\n");
}

// Set Filter Length to 1000
if (FAS_SetADConfig(nBdID, byChannel, TYPE_AD_FILTER_LENGTH, lFilterLen, &lRecv) != FMM_OK)
{
	printf("Function(FAS_SetADConfig) was failed.\n");
}

// Set Filter Offset to -1000
if (FAS_SetADConfig(nBdID, byChannel, TYPE_AD_FILTER_OFFSET, lFilterOffset, &lRecv) != FMM_OK)
{
	printf("Function(FAS_SetADConfig) was failed.\n");
}
```

FAS_SetADConfig() 함수를 사용하여 AD 관련 파라미터를 설정할 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'해당 보드의 ID번호', '채널 번호', '파라미터 타입', '파라미터 값', '파라미터에 적용된 값이 반환될 포인터'

### 1.1 AD_DATA_TYPE

AD_DATA_TYPE은 AD 파라미터를 식별하기 위해 선언된 enum 자료형입니다.
각 Type은 다음을 의미합니다.

TYPE_AD_RANGE: 아날로그 입력 범위
TYPE_AD_FILTER_LENGTH: Filter 길이
TYPE_AD_FILTER_OFFSET: AD 변환 Offset

AD_DATA_TYPE은 헤더파일 (MOTION_DEFINE.h)에서 확인하실 수 있습니다.

## 2. AD 파라미터 읽기
--------------------

``` c++
BYTE byChannel = 0; //Channel 0
int lRecv = 0;

printf("---------------------------------- \n");
// Get AD Range
if (FAS_GetADConfig(nBdID, byChannel, TYPE_AD_RANGE, &lRecv) != FMM_OK)
{
	printf("Function(FAS_GetADConfig) was failed.\n");
}

// Get Filter Length
if (FAS_GetADConfig(nBdID, byChannel, TYPE_AD_FILTER_LENGTH, &lRecv) != FMM_OK)
{
	printf("Function(FAS_GetADConfig) was failed.\n");
}

// Get Filter Offset
if (FAS_GetADConfig(nBdID, byChannel, TYPE_AD_FILTER_OFFSET, &lRecv) != FMM_OK)
{
	printf("Function(FAS_GetADConfig) was failed.\n");
}
```

FAS_GetADConfig() 함수를 사용하여 AD 관련 파라미터를 읽어올 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'해당 보드의 ID번호', '채널 번호', '파라미터 타입', '파라미터를 저장할 변수 포인터'

## 3. 예제 프로그램 시나리오 설명
-----------------------------

해당 예제프로그램의 시나리오는 아래와 같습니다.

1. 장치 연결.
2. AD 파라미터 설정.
3. AD 파라미터 읽기.
4. 연결 해제.

## 4. 기타
---------

1. 장치 연결 및 해제에 대한 함수 설명은 [01.ConnectionExam] 프로젝트 문서를 참고하시기 바랍니다.
