#include <iostream>
#include "../Include/FAS_EziMOTIONPlusE.h"

using namespace PE;

#define TCP 0
#define UDP 1

bool Connect(int nCommType, int nBdID);
bool ReadADValue(int nBdID);
bool ReadADAllValue(int nBdID);

int main()
{
	int nBdID = 0;

	// Device Connect
	if (Connect(TCP, nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Read AD
	if (ReadADValue(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Read All AD
	if (ReadADAllValue(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	//Connection Close
	FAS_Close(nBdID);

	getchar();
}

bool Connect(int nCommType, int nBdID)
{
	unsigned char byIP[4] = { 192, 168, 0, 2 }; // IP : 192.168.0.2
	bool bSuccess = true;

	// Connection
	switch (nCommType)
	{
	case TCP:
		// TCP Connection
		if (FAS_ConnectTCP(byIP[0], byIP[1], byIP[2], byIP[3], nBdID) == false)
		{
			printf("TCP Connection Fail! \n");
			bSuccess = false;
		}
		break;

	case UDP:
		// UDP Connection
		if (FAS_Connect(byIP[0], byIP[1], byIP[2], byIP[3], nBdID) == false)
		{
			printf("UDP Connection Fail! \n");
			bSuccess = false;
		}
		break;

	default:
		printf("Wrong communication type. \n");
		bSuccess = false;

		break;
	}

	if (bSuccess)
		printf("Connected successfully. \n");

	return bSuccess;
}

bool ReadADValue(int nBdID)
{
	unsigned char byChannel = 0;		//Channel 0
	short shRecv = 0;		//2Byte Read Buffer

	printf("---------------------------------- \n");
	// Read AD (Channel 0)
	if (FAS_ReadADValue(nBdID, byChannel, &shRecv) != FMM_OK)
	{
		printf("Function(FAS_ReadADValue) was failed.\n");
	}
	else
	{
		printf("Read AD Seuccess : Channel[%d] %d\n", byChannel + 1, shRecv);
	}

	return true;
}

bool ReadADAllValue(int nBdID)
{
	unsigned char byOffset = 0;	//Offset Should be 0
	AD_BUFFER adbuffer;	//2Byte Read Buffer * 8

	printf("---------------------------------- \n");
	// Read All AD
	if (FAS_ReadADAllValue(nBdID, byOffset, &adbuffer) != FMM_OK)
	{
		printf("Function(FAS_ReadADAllValue) was failed.\n");
	}
	else
	{
		printf("Read AD All Seuccess\r\n");
		for (int i = 0; i < 8; i++)
		{
			printf("Channel[%d] : %d\r\n", i + 1, adbuffer.channel[i]);
		}
	}

	return true;
}
