ReadADExam 예제
==============

## 1. 1개 채널의 AD 변환 값 읽기
-----------------------------

``` c++
bool ReadADValue(int nBdID)
{
	BYTE byChannel = 0;		//Channel 0
	short shRecv = 0;		//2Byte Read Buffer

	printf("---------------------------------- \n");
	// Read AD (Channel 0)
	if (FAS_ReadADValue(nBdID, byChannel, &shRecv) != FMM_OK)
	{
		printf("Function(FAS_ReadADValue) was failed.\n");
	}
	else
	{
		printf("Read AD Seuccess : Channel[%d] %d\n", byChannel + 1, shRecv);
	}

	return true;
}
```

FAS_ReadADValue() 함수를 사용하여 1개 채널에 대해 AD 변환 값 을 읽을 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'해당 보드의 ID번호', '채널 번호', 'AD 변환 값을 저장 할 변수 포인터'

## 2. 8개 채널의 AD 변환 값 읽기
-----------------------------

``` c++
bool ReadADAllValue(int nBdID)
{
	BYTE byOffset = 0;	//Offset Should be 0
	AD_BUFFER adbuffer;	//2Byte Read Buffer * 8

	printf("---------------------------------- \n");
	// Read All AD
	if (FAS_ReadADAllValue(nBdID, byOffset, &adbuffer) != FMM_OK)
	{
		printf("Function(FAS_ReadADAllValue) was failed.\n");
	}
	else
	{
		printf("Read AD All Seuccess\r\n");
		for (int i = 0; i < 8; i++)
		{
			printf("Channel[%d] : %d\r\n", i + 1, adbuffer.channel[i]);
		}
	}

	return true;
}
```

FAS_ReadADAllValue() 함수를 사용하여 8개 채널에 대해 AD 변환 값 을 읽을 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'해당 보드의 ID번호', 'Offset', 'AD 변환 값들을 저장 할 변수 포인터'
Offset은 0으로 송신해야 합니다.

### 2.1 AD_BUFFER

AD_BUFFER는 8개 채널에 대해 AD 변환 값을 관리하는 구조체 입니다. 
AD_BUFFER는 헤더파일 (MOTION_DEFINE.h)에서 확인하실 수 있습니다.

## 3. 예제 프로그램 시나리오 설명
-----------------------------

해당 예제프로그램의 시나리오는 아래와 같습니다.

1. 장치 연결.
2. 1개 채널의 AD 변환 값 읽기.
3. 8개 채널의 AD 변환 값 읽기.
4. 연결 해제.

## 4. 기타
---------

1. 장치 연결 및 해제에 대한 함수 설명은 [01.ConnectionExam] 프로젝트 문서를 참고하시기 바랍니다.
