#include <iostream>
#include "../Include/FAS_EziMOTIONPlusE.h"

using namespace PE;

#define TCP 0
#define UDP 1

bool Connect(int nCommType, int nBdID);
bool SetDACValue(int nBdID);
bool GetDACValue(int nBdID);

int main()
{
	int nBdID = 0;

	// Device Connect
	if (Connect(TCP, nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Set DAC Value
	if (SetDACValue(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Get DAC Value
	if (GetDACValue(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	//Connection Close
	FAS_Close(nBdID);

	getchar();
}

bool Connect(int nCommType, int nBdID)
{
	unsigned char byIP[4] = { 192, 168, 0, 2 }; // IP : 192.168.0.2
	bool bSuccess = true;

	// Connection
	switch (nCommType)
	{
	case TCP:
		// TCP Connection
		if (FAS_ConnectTCP(byIP[0], byIP[1], byIP[2], byIP[3], nBdID) == false)
		{
			printf("TCP Connection Fail! \n");
			bSuccess = false;
		}
		break;

	case UDP:
		// UDP Connection
		if (FAS_Connect(byIP[0], byIP[1], byIP[2], byIP[3], nBdID) == false)
		{
			printf("UDP Connection Fail! \n");
			bSuccess = false;
		}
		break;

	default:
		printf("Wrong communication type. \n");
		bSuccess = false;

		break;
	}

	if (bSuccess)
		printf("Connected successfully. \n");

	return bSuccess;
}

bool SetDACValue(int nBdID)
{
	unsigned char byChannel = 0;		//Channel = 0
	int bEnable = 1;	//Enable = True
	int lDACValue = 10000;	//DAC Value = 10000

	printf("---------------------------------- \n");
	// Set DAC Value to 10000
	if (FAS_SetDACValue(nBdID, byChannel, bEnable, lDACValue) != FMM_OK)
	{
		printf("Function(FAS_SetDACValue) was failed.\n");
	}
	else
	{
		printf("Set DAC Value Seuccess\n");
	}

	return true;
}

bool GetDACValue(int nBdID)
{
	int bEnable = 0;	//Enable
	int lRecv = 0;		//DAC Value

	printf("---------------------------------- \n");
	// Get DAC Value
	if (FAS_GetDACValue(nBdID, 0, &bEnable, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetDACValue) was failed.\n");
	}
	else
	{
		printf("Get DAC Value Seuccess : Enable = %d, DAC = %d \n", bEnable, lRecv);
	}

	return true;
}
