SetDACValueExam 예제
===================

## 1. DAC 변환 값 설정
--------------------

``` c++
BYTE byChannel = 0;		//Channel = 0
BOOL bEnable = TRUE;	//Enable = True
int lDACValue = 10000;	//DAC Value = 10000

printf("---------------------------------- \n");
// Set DAC Value to 10000
if (FAS_SetDACValue(nBdID, byChannel, bEnable, lDACValue) != FMM_OK)
{
	printf("Function(FAS_SetDACValue) was failed.\n");
}
```

FAS_SetDACValue() 함수를 사용하여 DAC 변환 값을 설정할 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'해당 보드의 ID번호', '채널 번호', 'DAC 기능 활성화 여부 ', 'DAC 변환 값'

## 2. DAC 변환 값 읽기
--------------------

``` c++
BOOL bEnable = 0;	//Enable
int lRecv = 0;		//DAC Value

printf("---------------------------------- \n");
// Get DAC Value
if (FAS_GetDACValue(nBdID, 0, &bEnable, &lRecv) != FMM_OK)
{
	printf("Function(FAS_GetDACValue) was failed.\n");
}
```

FAS_GetDACValue() 함수를 사용하여 DAC 값을 읽어올 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'해당 보드의 ID번호', '채널 번호', 'DAC 기능 활성화 여부를 저장할 변수 포인터', 'DAC 값을 저장할 변수 포인터'

## 3. 예제 프로그램 시나리오 설명
-----------------------------

해당 예제프로그램의 시나리오는 아래와 같습니다.

1. 장치 연결.
2. DAC 변환 값 설정.
3. DAC 변환 값 읽기.
4. 연결 해제.

## 4. 기타
---------

1. 장치 연결 및 해제에 대한 함수 설명은 [01.ConnectionExam] 프로젝트 문서를 참고하시기 바랍니다.
