#include <iostream>
#include "../Include/FAS_EziMOTIONPlusE.h"

using namespace PE;

#define TCP 0
#define UDP 1

bool Connect(int nCommType, int nBdID);
bool SetCounterConfig(int nBdID);
bool GetCounterConfig(int nBdID);

int main()
{
	int nBdID = 0;

	// Device Connect
	if (Connect(TCP, nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Get Counter Config
	if (GetCounterConfig(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Set Counter Config
	if (SetCounterConfig(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Get Counter Config
	if (GetCounterConfig(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	//Connection Close
	FAS_Close(nBdID);

	getchar();
}

bool Connect(int nCommType, int nBdID)
{
	unsigned char byIP[4] = { 192, 168, 0, 2 }; // IP : 192.168.0.2
	bool bSuccess = true;

	// Connection
	switch (nCommType)
	{
	case TCP:
		// TCP Connection
		if (FAS_ConnectTCP(byIP[0], byIP[1], byIP[2], byIP[3], nBdID) == false)
		{
			printf("TCP Connection Fail! \n");
			bSuccess = false;
		}
		break;

	case UDP:
		// UDP Connection
		if (FAS_Connect(byIP[0], byIP[1], byIP[2], byIP[3], nBdID) == false)
		{
			printf("UDP Connection Fail! \n");
			bSuccess = false;
		}
		break;

	default:
		printf("Wrong communication type. \n");
		bSuccess = false;

		break;
	}

	if (bSuccess)
		printf("Connected successfully. \n");

	return bSuccess;
}

bool SetCounterConfig(int nBdID)
{
	unsigned char byChannel = 0;				//Channel = 0
	int lRecv = 0;

	printf("---------------------------------- \n");
	// Set Counter Input Mode
	if (FAS_SetCounterConfig(nBdID, byChannel, CFG_INPUT_MODE, 1, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_SetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Set Counter Config Seuccess : Counter Type%d(CFG_INPUT_MODE)\n", CFG_INPUT_MODE);
	}

	// Set Counter Direction
	if (FAS_SetCounterConfig(nBdID, byChannel, CFG_COUNT_DIRECTION, 1, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_SetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Set Counter Config Seuccess : Counter Type%d(CFG_COUNT_DIRECTION)\n", CFG_COUNT_DIRECTION);
	}

	// Set Counter Latch A Mode
	if (FAS_SetCounterConfig(nBdID, byChannel, CFG_LATCHA_MODE, 1, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_SetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Set Counter Config Seuccess : Counter Type%d(CFG_LATCHA_MODE)\n", CFG_LATCHA_MODE);
	}

	// Set Counter Latch B Mode
	if (FAS_SetCounterConfig(nBdID, byChannel, CFG_LATCHB_MODE, 1, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_SetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Set Counter Config Seuccess : Counter Type%d(CFG_LATCHB_MODE)\n", CFG_LATCHB_MODE);
	}

	// Set Counter Z-Phase Latch Mode
	if (FAS_SetCounterConfig(nBdID, byChannel, CFG_ZLATCH_MODE, 1, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_SetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Set Counter Config Seuccess : Counter Type%d(CFG_ZLATCH_MODE)\n", CFG_ZLATCH_MODE);
	}

	// Set Counter Latch A Logic
	if (FAS_SetCounterConfig(nBdID, byChannel, CFG_LATCHA_LOGIC, 1, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_SetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Set Counter Config Seuccess : Counter Type%d(CFG_LATCHA_LOGIC)\n", CFG_LATCHA_LOGIC);
	}

	// Set Counter Latch B Logic
	if (FAS_SetCounterConfig(nBdID, byChannel, CFG_LATCHB_LOGIC, 1, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_SetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Set Counter Config Seuccess : Counter Type%d(CFG_LATCHB_LOGIC)\n", CFG_LATCHB_LOGIC);
	}

	// Set Counter Z-Phase Latch Logic
	if (FAS_SetCounterConfig(nBdID, byChannel, CFG_ZLATCH_LOGIC, 1, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_SetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Set Counter Config Seuccess : Counter Type%d(CFG_ZLATCH_LOGIC)\n", CFG_ZLATCH_LOGIC);
	}

	// Set Counter Reset Logic
	if (FAS_SetCounterConfig(nBdID, byChannel, CFG_RESET_LOGIC, 1, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_SetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Set Counter Config Seuccess : Counter Type%d(CFG_RESET_LOGIC)\n", CFG_RESET_LOGIC);
	}

	// Set Counter Comparison Output Logic
	if (FAS_SetCounterConfig(nBdID, byChannel, CFG_CP_LOGIC, 1, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_SetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Set Counter Config Seuccess : Counter Type%d(CFG_CP_LOGIC)\n", CFG_CP_LOGIC);
	}

	return true;
}

bool GetCounterConfig(int nBdID)
{
	unsigned char byChannel = 0;	//Channel 0
	int lRecv = 0;

	printf("---------------------------------- \n");
	// Get Counter Input Mode
	if (FAS_GetCounterConfig(nBdID, byChannel, CFG_INPUT_MODE, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Counter Type%d(CFG_INPUT_MODE) : %d\n", CFG_INPUT_MODE, lRecv);
	}

	// Get Counter Direction
	if (FAS_GetCounterConfig(nBdID, byChannel, CFG_COUNT_DIRECTION, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Counter Type%d(CFG_COUNT_DIRECTION) : %d\n", CFG_COUNT_DIRECTION, lRecv);
	}

	// Get Counter Latch A Mode
	if (FAS_GetCounterConfig(nBdID, byChannel, CFG_LATCHA_MODE, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Counter Type%d(CFG_LATCHA_MODE) : %d\n", CFG_LATCHA_MODE, lRecv);
	}

	// Get Counter Latch B Mode
	if (FAS_GetCounterConfig(nBdID, byChannel, CFG_LATCHB_MODE, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Counter Type%d(CFG_LATCHB_MODE) : %d\n", CFG_LATCHB_MODE, lRecv);
	}

	// Get Counter Z-Phase Latch Mode
	if (FAS_GetCounterConfig(nBdID, byChannel, CFG_ZLATCH_MODE, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Counter Type%d(CFG_ZLATCH_MODE) : %d\n", CFG_ZLATCH_MODE, lRecv);
	}

	// Get Counter Latch A Logic
	if (FAS_GetCounterConfig(nBdID, byChannel, CFG_LATCHA_LOGIC, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Counter Type%d(CFG_LATCHA_LOGIC) : %d\n", CFG_LATCHA_LOGIC, lRecv);
	}

	// Get Counter Latch B Logic
	if (FAS_GetCounterConfig(nBdID, byChannel, CFG_LATCHB_LOGIC, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Counter Type%d(CFG_LATCHB_LOGIC) : %d\n", CFG_LATCHB_LOGIC, lRecv);
	}

	// Get Counter Z-Phase Latch Logic
	if (FAS_GetCounterConfig(nBdID, byChannel, CFG_ZLATCH_LOGIC, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Counter Type%d(CFG_ZLATCH_LOGIC) : %d\n", CFG_ZLATCH_LOGIC, lRecv);
	}

	// Get Counter Reset Logic
	if (FAS_GetCounterConfig(nBdID, byChannel, CFG_RESET_LOGIC, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Counter Type%d(CFG_RESET_LOGIC) : %d\n", CFG_RESET_LOGIC, lRecv);
	}

	// Get Counter Comparison Output Logic
	if (FAS_GetCounterConfig(nBdID, byChannel, CFG_CP_LOGIC, &lRecv) != FMM_OK)
	{
		printf("Function(FAS_GetCounterConfig) was failed.\n");
	}
	else
	{
		printf("Counter Type%d(CFG_CP_LOGIC) : %d\n", CFG_CP_LOGIC, lRecv);
	}

	return true;
}
