SetCounterConfigExam 예제
===================

## 1. Counter Config 설정
--------------------

``` c++
BYTE byChannel = 0;				//Channel = 0
int lRecv = 0;

printf("---------------------------------- \n");
// Set Counter Input Mode
if (FAS_SetCounterConfig(nBdID, byChannel, CFG_INPUT_MODE, 1, &lRecv) != FMM_OK)
{
	printf("Function(FAS_SetCounterConfig) was failed.\n");
}
.....
```

FAS_SetCounterConfig() 함수를 사용하여 Counter Config를 설정할 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'해당 보드의 ID번호', '채널 번호', 'Counter Config Type', '수정할 값'

### 1.1 Counter Config Type

COUNTER_CONFIG(CFG_INPUT_MODE)는 Counter Config Type이 정리된 구조체이며 헤더파일 (MOTION_DEFINE.h)에서 확인하실 수 있습니다.

## 2. Counter Config 설정 값 읽기
--------------------

``` c++
BYTE byChannel = 0;	//Channel 0
int lRecv = 0;

printf("---------------------------------- \n");
// Get Counter Input Mode
if (FAS_GetCounterConfig(nBdID, byChannel, CFG_INPUT_MODE, &lRecv) != FMM_OK)
{
	printf("Function(FAS_GetCounterConfig) was failed.\n");
}
.....
```

FAS_GetCounterConfig() 함수를 사용하여 설정된 Counter Config 값을 읽어올 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'해당 보드의 ID번호', '채널 번호', '읽어들일 Counter Config Type 번호', '읽어들인 값을 저장할 변수'

## 3. 예제 프로그램 시나리오 설명
-----------------------------

해당 예제프로그램의 시나리오는 아래와 같습니다.

1. 장치 연결.
2. Counter Config 값 읽기.
3. Counter Config 값 설정.
2. 수정 된 Counter Config 값 읽기.
5. 연결 해제.

## 4. 기타
---------

1. 장치 연결 및 해제에 대한 함수 설명은 [01.ConnectionExam] 프로젝트 문서를 참고하시기 바랍니다.
