#include <iostream>
#include "../Include/FAS_EziMOTIONPlusE.h"

using namespace PE;

#define TCP 0
#define UDP 1

bool Connect(int nCommType, int nBdID);
bool CounterCommand(int nBdID);
bool GetCounterStatus(int nBdID);

int main()
{
	int nBdID = 0;

	// Device Connect
	if (Connect(TCP, nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Get Counter Config
	if (GetCounterStatus(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Set Counter Config
	if (CounterCommand(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	// Get Counter Config
	if (GetCounterStatus(nBdID) == false)
	{
		getchar();
		exit(1);
	}

	//Connection Close
	FAS_Close(nBdID);

	getchar();
}

bool Connect(int nCommType, int nBdID)
{
	unsigned char byIP[4] = { 192, 168, 0, 2 }; // IP : 192.168.0.2
	bool bSuccess = true;

	// Connection
	switch (nCommType)
	{
	case TCP:
		// TCP Connection
		if (FAS_ConnectTCP(byIP[0], byIP[1], byIP[2], byIP[3], nBdID) == false)
		{
			printf("TCP Connection Fail! \n");
			bSuccess = false;
		}
		break;

	case UDP:
		// UDP Connection
		if (FAS_Connect(byIP[0], byIP[1], byIP[2], byIP[3], nBdID) == false)
		{
			printf("UDP Connection Fail! \n");
			bSuccess = false;
		}
		break;

	default:
		printf("Wrong communication type. \n");
		bSuccess = false;

		break;
	}

	if (bSuccess)
		printf("Connected successfully. \n");

	return bSuccess;
}

bool CounterCommand(int nBdID)
{
	unsigned char byChannel = 0;				//Channel = 0

	printf("---------------------------------- \n");
	// Set Counter Command Channel Enable
	if (FAS_CounterCommand(nBdID, byChannel, CNTCMD_CH_ENABLE, 1) != FMM_OK)
	{
		printf("Function(FAS_CounterCommand) was failed.\n");
	}
	else
	{
		printf("Set Counter Command Seuccess : Counter Type%d(CNTCMD_CH_ENABLE)\n", CNTCMD_CH_ENABLE);
	}

	// Set Counter Command Latch A Enable
	if (FAS_CounterCommand(nBdID, byChannel, CNTCMD_LATCHA_ENABLE, 1) != FMM_OK)
	{
		printf("Function(FAS_CounterCommand) was failed.\n");
	}
	else
	{
		printf("Set Counter Command Seuccess : Counter Type%d(CNTCMD_LATCHA_ENABLE)\n", CNTCMD_LATCHA_ENABLE);
	}

	// Set Counter Command Latch B Enable
	if (FAS_CounterCommand(nBdID, byChannel, CNTCMD_LATCHB_ENABLE, 1) != FMM_OK)
	{
		printf("Function(FAS_CounterCommand) was failed.\n");
	}
	else
	{
		printf("Set Counter Command Seuccess : Counter Type%d(CNTCMD_LATCHB_ENABLE)\n", CNTCMD_LATCHB_ENABLE);
	}

	// Set Counter Command Z-Phase Latch Enable
	if (FAS_CounterCommand(nBdID, byChannel, CNTCMD_ZLATCH_ENABLE, 1) != FMM_OK)
	{
		printf("Function(FAS_CounterCommand) was failed.\n");
	}
	else
	{
		printf("Set Counter Command Seuccess : Counter Type%d(CNTCMD_ZLATCH_ENABLE)\n", CNTCMD_ZLATCH_ENABLE);
	}

	// Set Counter Command Reset All
	if (FAS_CounterCommand(nBdID, byChannel, CNTCMD_RESET_ALL, 1) != FMM_OK)
	{
		printf("Function(FAS_CounterCommand) was failed.\n");
	}
	else
	{
		printf("Set Counter Command Seuccess : Counter Type%d(CNTCMD_RESET_ALL)\n", CNTCMD_RESET_ALL);
	}

	// Set Counter Command Reset Count
	if (FAS_CounterCommand(nBdID, byChannel, CNTCMD_RESET_COUNT, 0) != FMM_OK)
	{
		printf("Function(FAS_CounterCommand) was failed.\n");
	}
	else
	{
		printf("Set Counter Command Seuccess : Counter Type%d(CNTCMD_RESET_COUNT)\n", CNTCMD_RESET_COUNT);
	}

	// Set Counter Command Reset Latch
	if (FAS_CounterCommand(nBdID, byChannel, CNTCMD_RESET_LATCH, 1) != FMM_OK)
	{
		printf("Function(FAS_CounterCommand) was failed.\n");
	}
	else
	{
		printf("Set Counter Command Seuccess : Counter Type%d(CNTCMD_RESET_LATCH)\n", CNTCMD_RESET_LATCH);
	}

	return true;
}

bool GetCounterStatus(int nBdID)
{
	unsigned int dwStatus = 0;

	printf("---------------------------------- \n");
	// Get Counter Status
	if (FAS_GetCounterStatus(nBdID, &dwStatus) != FMM_OK)
	{
		printf("Function(FAS_GetCounterStatus) was failed.\n");
	}
	else
	{
		printf("Counter Status : 0x%08x\n", dwStatus);
	}

	return true;
}
