CounterCommandExam 예제
===================

## 1. Counter Command 설정
--------------------

``` c++
BYTE byChannel = 0;				//Channel = 0

printf("---------------------------------- \n");
// Set Counter Command Channel Enable
if (FAS_CounterCommand(nBdID, byChannel, CNTCMD_CH_ENABLE, 1) != FMM_OK)
{
	printf("Function(FAS_CounterCommand) was failed.\n");
}
.....
```

FAS_CounterCommand() 함수를 사용하여 Counter Command를 설정할 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'해당 보드의 ID번호', '채널 번호', 'Counter Command Type', '수정할 값'

### 1.1 Counter Command Type

COUNTER_CMD(CNTCMD_CH_ENABLE)는 Counter Command Type이 정리된 구조체이며 헤더파일 (MOTION_DEFINE.h)에서 확인하실 수 있습니다.

## 2. Counter Command 값 읽기
--------------------

``` c++
DWORD dwStatus = 0;

printf("---------------------------------- \n");
// Get Counter Status
if (FAS_GetCounterStatus(nBdID, &dwStatus) != FMM_OK)
{
	printf("Function(FAS_GetCounterStatus) was failed.\n");
}
```

FAS_GetCounterStatus() 함수를 사용하여 설정된 Counter Command 값을 읽어올 수 있습니다.
해당 함수의 각 파라미터는 순차적으로 다음을 의미합니다.
'해당 보드의 ID번호', '읽어들인 값을 저장할 변수 (BitMask로 저장됨)'

### 2.1 Counter Command BitMask

읽어들인 Counter Command BitMask는 하위 4Byte는 Cnt1, 상위 4Byte는 Cnt2를 표시하며 다음과 같습니다.
0x0001: Enabled
0x0002: Latch A Enabled
0x0004: Latch B Enabled
0x0008: Z-Phase Latch Enabled
0x0010: Latch A Latcheds
0x0020: Latch B Latcheds
0x0040: Z-Phase Latch Latcheds
0x0080: Reset
0x0100: Trigger Status
0x0200: Comparison
자세한 내용은 헤더파일 (MOTION_DEFINE.h)에서 확인하실 수 있습니다.

## 3. 예제 프로그램 시나리오 설명
-----------------------------

해당 예제프로그램의 시나리오는 아래와 같습니다.

1. 장치 연결.
2. Counter Command 값 읽기.
3. Counter Command 설정.
2. 수정 된 Counter Command 값 읽기.
5. 연결 해제.

## 4. 기타
---------

1. 장치 연결 및 해제에 대한 함수 설명은 [01.ConnectionExam] 프로젝트 문서를 참고하시기 바랍니다.
